<?php

namespace WPCWV; 

if (!defined('ABSPATH')) {
    die('Let\'s not do this');
}
?>
<div class="cwv-tab-panel" id="tab-css" style="display: none;">
    <h2 class="cwv-tab-heading">
        <svg class="icon">
            <use xlink:href="#icon-css3"></use>
        </svg>
        Styles - Critical CSS
        <svg data-help=".criticalcssoptshelp" class="cwv-help helpicon">
            <use xlink:href="#icon-question"></use>
        </svg>
    </h2>


    <div class="cwvhelptext criticalcssoptshelp">
        <p>Critcal CSS is a collection of only the styles that are needed for rendering the visible viewport. While original stylesheets are loaded in the background the browser can start rendering the page without needing to wait for external stylesheets.</p>
        <p>We strongly recommend that you only serve critical CSS to new visitors because repeat visitors will most likely have the requested CSS files in their (ultra-fast) browser cache</p>



    </div>


    <table class="form-table">
        <tr valign="top">
            <th scope="row">Generate Critical CSS</th>
            <td>
                <div class="switch-field">
                    <input name="wp_cwv_css" id="wp_cwv_css0" type="radio" value="0" <?php checked('0', cwv_options::get('wp_cwv_css')); ?> />
                    <label for="wp_cwv_css0">no</label>
                    <input name="wp_cwv_css" id="wp_cwv_css1" type="radio" value="1" <?php checked('1', cwv_options::get('wp_cwv_css')); ?> />
                    <label for="wp_cwv_css1">yes</label>
                </div>
                <p class="inlinehelp">Critcal CSS is a collection of only the styles that are needed for rendering the visible viewport. While original stylesheets are loaded in the background the browser can start rendering the page without needing to wait for external stylesheets</p>
            </td>
        </tr>

        <tr valign="top" data-depends="wp_cwv_css">
            <th scope="row">Critical CSS only for new visitors</th>
            <td>
                <div class="switch-field">
                    <input name="wp_cwv_critcal_css_only_new" id="wp_cwv_critcal_css_only_new0" type="radio" value="0" <?php checked('0', cwv_options::get('wp_cwv_critcal_css_only_new')); ?> />
                    <label for="wp_cwv_critcal_css_only_new0">no</label>
                    <input name="wp_cwv_critcal_css_only_new" id="wp_cwv_critcal_css_only_new1" type="radio" value="1" <?php checked('1', cwv_options::get('wp_cwv_critcal_css_only_new')); ?> />
                    <label for="wp_cwv_critcal_css_only_new1">yes</label>
                </div>
                <p class="inlinehelp">Serve Critical CSS only for new visitors. This saves bandwidth for returning visitors and is considered best practice!</p>
            </td>
        </tr>
        <tr valign="top" data-depends="wp_cwv_css">
            <th scope="row">Original CSS Priority</th>
            <td>
                <div class="switch-field">
                    <input name="wp_cwv_critical_prio" id="wp_cwv_critical_prio0" type="radio" value="0" <?php checked('0', cwv_options::get('wp_cwv_critical_prio')); ?> />
                    <label for="wp_cwv_critical_prio0">low</label>
                    <input name="wp_cwv_critical_prio" id="wp_cwv_critical_prio1" type="radio" value="1" <?php checked('1', cwv_options::get('wp_cwv_critical_prio')); ?> />
                    <label for="wp_cwv_critical_prio1">high</label>
                </div>
                <p class="inlinehelp">High Original CSS Priority will enqueue the original CSS files a bit earlier then with low priority. Setting this option to high might impact your paint metrics.</p>
            </td>
        </tr>
    </table>
    <h2 class="cwv-tab-heading">
        <svg class="icon">
            <use xlink:href="#icon-css3"></use>
        </svg>
        Styles - Compression and filesize
        <svg data-help=".csscompressionhelp" class="cwv-help helpicon">
            <use xlink:href="#icon-question"></use>
        </svg>
    </h2>


    <div class="cwvhelptext csscompressionhelp">
        <p>Optimizing the CSS fielsize will combine your CSS files into multiple-same sized CSS files.
            This will optmize the CSS load time and reduce render delay caused by CSS files.
            This will work fine for most sites but can break your CSS if you have errors in your CSS. Be carefull with this feature!
        </p>
        <p>Compress CSS will minimize your CSS. This will work fine for most sites but can break your CSS if you have errors in your CSS. Be carefull with this feature.</p>



    </div>


    <table class="form-table">

        <tr valign="top">
            <th scope="row">Optimize CSS filesize</th>
            <td>
                <div class="switch-field">
                    <input name="cwv_combine_css" id="cwv_combine_css0" type="radio" value="0" <?php checked('0', cwv_options::get('cwv_combine_css')); ?> />
                    <label for="cwv_combine_css0">no</label>
                    <input name="cwv_combine_css" id="cwv_combine_css2" type="radio" value="2" <?php checked('2', cwv_options::get('cwv_combine_css')); ?> />
                    <label for="cwv_combine_css2">single file</label>
                    <input name="cwv_combine_css" id="cwv_combine_css3" type="radio" value="3" <?php checked('3', cwv_options::get('cwv_combine_css')); ?> />
                    <label for="cwv_combine_css3">smart</label>
                    <input name="cwv_combine_css" id="cwv_combine_css1" type="radio" value="1" <?php checked('1', cwv_options::get('cwv_combine_css')); ?> />
                    <label for="cwv_combine_css1">optimized number</label>
                </div>
                <p class="inlinehelp">This setting will combine your CSS files into multiple-same sized CSS files.
                    This will optmize the CSS load time and reduce render delay caused by CSS files.</p>
            </td>
        </tr>
        <tr valign="top" data-depends="cwv_combine_css">
            <th scope="row">Optimize inline CSS</th>
            <td>
                <div class="switch-field">
                    <input name="cwv_combine_inline_css" id="cwv_combine_inline_css0" type="radio" value="0" <?php checked('0', cwv_options::get('cwv_combine_inline_css')); ?> />
                    <label for="cwv_combine_inline_css0">no</label>
                    <input name="cwv_combine_inline_css" id="cwv_combine_inline_css1" type="radio" value="1" <?php checked('1', cwv_options::get('cwv_combine_inline_css')); ?> />
                    <label for="cwv_combine_inline_css1">yes</label>
                </div>
                <p class="inlinehelp">This will move your inline styles to external stylesheets and make those styles cache-able. 
                    However this can create many external stylesheets and should only be used if inline styles are consistent! Be carefull with this feature</p>
            </td>
        </tr>
        <tr valign="top" data-depends="cwv_combine_css">
            <th scope="row">Compress CSS</th>
            <td>
                <div class="switch-field">
                    <input name="compress_css" id="compress_css0" type="radio" value="0" <?php checked('0', cwv_options::get('compress_css')); ?> />
                    <label for="compress_css0">no</label>
                    <input name="compress_css" id="compress_css1" type="radio" value="1" <?php checked('1', cwv_options::get('compress_css')); ?> />
                    <label for="compress_css1">yes</label>
                </div>
                <p class="inlinehelp">Compressing your CSS will minimze the CSS filesize but can break your CSS. Be carefull with this feature</p>
            </td>
        </tr>




    </table>
    <br />
    <br />
    <h2 class="cwv-tab-heading">
        <svg class="icon">
            <use xlink:href="#icon-css3"></use>
        </svg>
        Styles - Advanced options
        <svg data-help=".advancedstyleshelp" class="cwv-help helpicon">
            <use xlink:href="#icon-question"></use>
        </svg>
    </h2>
    <div class="cwvhelptext advancedstyleshelp">
        <p>This is a list of all generated Critical CSS files. We will generate a critical CSS file of each page type, template and post type combination.</p>
    </div>
    <table class="form-table">

`

        <tr valign="top">
            <th scope="row">Ignore optimization for (regex)</th>
            <td>
                <input type="text" name="cwv_css_lower_regex" value="<?php echo esc_attr(cwv_options::get('cwv_css_lower_regex')); ?>" />
                <p class="inlinehelp">If you need to ignore a CSS file and just keep it the way it is you can add a regex here.
                    This will prevent the CSS file from being optimized. To match main.min.css and extra.min.css type <i>"main|extra"</i></p>
            </td>
        </tr>
        <tr valign="top">
            <th scope="row">Add extra CSS</th>
            <td>
                <textarea type="text" name="cwv_extra_css"><?php echo esc_attr(stripslashes(cwv_options::get('cwv_extra_css'))); ?></textarea>
                <p class="inlinehelp">Use this to correct tiny Critical CSS mistakes. This CSS will be added to the Inline Critical CSS.</p>
            </td>
        </tr>
    </table>

    <div data-depends="wp_cwv_css">
        <br />
        <br />
        <h2 class="cwv-tab-heading">
            <svg class="icon">
                <use xlink:href="#icon-css3"></use>
            </svg>
            Generated Critical Files
            <svg data-help=".generatedcriticalcsshelp" class="cwv-help helpicon">
                <use xlink:href="#icon-question"></use>
            </svg>
        </h2>
        <p>This is a list of all generated Critical CSS files. We will generate a critical CSS file of each page type, template and post type combination.</p>

        <div class="cwvhelptext generatedcriticalcsshelp">
            <p>This is a list of all generated Critical CSS files. We will generate a critical CSS file of each page type, template and post type combination.</p>
        </div>
        <table class="bordered" id="criticalfiles">
            <tr>
                <th>Example url</th>
                <th>Page type</th>
                <th>Template</th>
                <th>Post type</th>
                <th></th>
            </tr>
            <?php foreach ($oCriticalFiles as $oCriticalFile) { ?>
                <tr>
                    <td>

                        <a href="/wp-content/cache/wp_cwv/critical/<?php echo $oCriticalFile->hash; ?>.css"><?php echo $oCriticalFile->url; ?></a>
                    </td>
                    <td>
                        <?php echo $oCriticalFile->pagetype; ?>
                    </td>
                    <td>
                        <?php echo ($oCriticalFile->templateslug) ? $oCriticalFile->templateslug : '--'; ?>
                    </td>
                    <td>
                        <?php echo $oCriticalFile->posttype; ?>
                    </td>
                    <td><span class="fetchnow badge badge-<?php echo $oCriticalFile->status; ?>">
                            <?php echo $oCriticalFile->status; ?></span></td>
                </tr>
            <?php } ?>
        </table>
        <br />
        <br />
        <h2 class="cwv-tab-heading">
            <svg class="icon">
                <use xlink:href="#icon-css3"></use>
            </svg>
            Critical Rules
            <svg data-help=".criticalcssruleshelp" class="cwv-help helpicon">
                <use xlink:href="#icon-question"></use>
            </svg>
        </h2>
        <p class="inlinehelp">Create different Critical CSS files for any url that start with:</p>
        <div class="cwvhelptext criticalcssruleshelp">
            <p>
                If you need more Critical CSS rules because pages with the same combination of 'Page type', 'Template' and 'Post type' have different lay-outs or styles just add (part of) their url into a new rule. WP Core Web Vitals will then generate seperate Critical Styles for all pages mathcing this rule!
            </p>
            <p>
                For example: '<b>blog/</b>' will match any page that has blog/ in the url. For example
                <?php echo WP_CWV_SITE_URL; ?>/<b>blog/</b>my-first-blog.
            </p>
        </div>
        <div id="criticalcssrules">
        </div>
    </div>
</div>