<?php


namespace WPCWV;

function formatCssClass($class)
{
    $all = explode(' ', trim($class));
    foreach ($all as $k => $c) {
        $delim = ($k == sizeof($all) - 1) ? '  ' : ' or ';
        echo '<b>.' . $c . '</b>' . $delim;
    }
}

if (!defined('ABSPATH')) {
    die('Let\'s not do this');
}
?>
<div class="cwv-tab-panel" id="tabs-dashboard">
    <h2 class="cwv-tab-heading">
        <svg class="icon">
            <use xlink:href="#icon-dashboard"></use>
        </svg>
        Dashboard
    </h2>
    <br />
    <div class="cwvcard pl tl intro">
        <div class="ig">
            <img src="https://www.corewebvitals.io/static/img/resize-90-90/s/arjen-sq.webp">
            <div>
                <p style="padding:0;margin:0;">

                    Hi there, I’m Arjen. I am a Core Web Vitals specialist & Web Performance Consultant from the Netherlands.
                    <br /><br />

                    I am dedicated to making the internet a faster place and that is why I have made WP Core Web Vitals <b>free for everyone!</b>
                    <br />
                    <br />

                    WP Core Web Vitals offers more flexibility in fixing Core Web Vitals issues and that is why WP Core Web Vitals currently outperforms all other pagespeed plugins (without dirty tricks or manipulating your lighthouse score!)
                    <br /><br />
                    Start by properly configuring this plugin. That will take some time and maybe a bit of reading up on the Core Web Vitals.
                    The end result will be worth it!
                </p>
            </div>
        </div>
    </div>


    <div class="g11">
        <div>
        <span></span>
            <h2 class="cwv-tab-heading">
                <svg class="icon">
                    <use xlink:href="#icon-pro"></use>
                </svg>
                PageSpeed Score
            </h2>
            <div class="mt">
            <div id="metrics">
                <div class="metric cwvcard" id="homeLCP">
                    <div>LCP</div>
                    <div id="LCP_value">1.32s</div>
                    <div id="LCP_score"><span class="btn">no data</span></div>
                </div>

                <div class="metric cwvcard" id="homeFID">
                    <div>FID</div>
                    <div id="FID_value">1ms</div>
                    <div id="FID_score"><span class="btn">no data</span></div>
                </div>



                <div class="metric cwvcard" id="homeCLS">
                    <div>CLS</div>
                    <div id="CLS_value">0.000</div>
                    <div id="CLS_score"><span class="btn">no data</span></div>
                </div>


                <div class="metric cwvcard" id="homeFCP">
                    <div>FCP</div>
                    <div id="FCP_value">1.32s</div>
                    <div id="FCP_score"><span class="btn">no data</span></div>
                </div>


                <div class="metric cwvcard" id="homeINP">
                    <div>INP</div>
                    <div id="INP_value">0ms</div>
                    <div id="INP_score"><span class="btn">no data</span></div>
                </div>



                <div class="metric cwvcard" id="homeTTFB">
                    <div>TTFB</div>
                    <div id="TTFB_value">1.19s</div>
                    <div id="TTFB_score"><span class="btn">Improve</span></div>
                </div>


            </div>
        </div>
        </div>

        <div>
        <span></span>
            <h2 class="cwv-tab-heading">
                <svg class="icon">
                    <use xlink:href="#icon-pro"></use>
                </svg>
                WP Core Web Vitals news!
            </h2>
            <div class="cwvcard mt">

                <ul>
                    <li><b>103 - Early hints</b> Early hint is supported through the Link header</li>
                    <li><b>Page prerender / prefetch</b> Dynamically preload or prefetch pages for faster TTFB</li>
                    <li><b>JavaScript loader</b> Lots of improvement for the JavaScript loader that will make your scripts load even faster without blocking the page!</li>
                    <li><b>Improved RUM data</b> New timeline view, desktop and mobile filter, zoom in on url details level & faster RUM data</li>
                    <li><b>Ultra fast caching</b> Faster caching (beta) and common tracking parameters are now ignored by the cache by default</li>
                    <li><b>WebP & AVIF Image support</b> AVIF and WebP images can be enabled through the beta settings!.</li>
                    <!--<li><b>Resource Hints</b> The resource hints section has been rewritten and gives you back full control over the resource hints.</li>
                    <li><b>Image preloads</b> We can detect, and rewrite picture source elements and preload them with media attributes if they match LCP rules.</li>
                     <li><b>Upgraded Critical CSS cluster</b> Generate Critical CSS faster and more reliable!</li> -->
                     <!-- <li><b>Preload improvements</b> Added the option to remove prefetch and preload tags.</li>
                    <li><b>Style improvements</b> Combined styles are better placed for the preload scanner and use less CPU.</li>
                   <li><b>Cache improvements</b> You can now auto clear certain pages when creating a new post.</li>
        <li><b>Cache improvements</b> Automatic cache preloading is now available.</li>
        <li><b>Beta feature: fonts</b> You can now upload and optimize your own font files.</li>
        <li><b>Cache improvements</b> You can now exclude pages from being cached.</li>
        <li><b>WP Core Web Vitals is now free</b> WP Core Web Vitals is now free for all users. We have made all the PRO features available to all users.</li> -->
                </ul>
            </div>

        </div>

    </div>


    <h2 class="cwv-tab-heading">
        <svg class="icon">
            <use xlink:href="#icon-advisor"></use>
        </svg>
        Core Web Vitals advisor
    </h2>
    <div class="cwvcard mt">
        <p>
            Please take some time to properly configure WP core Web Vitals!
            Each site is different and requires a slightly different configuration for optimal results!
            Click-and-go might seem appealing but for the best results <a href="https://www.corewebvitals.io/wp-core-web-vitals/installation">read the documentation!</a>
        </p>


        <!-- <table class="form-table">
            <tr valign="top">
                <th scope="row">Enable the advisor?</th>
                <td>
                    <div class="switch-field">
                        <input name="wp_cwv_advisor" id="wp_cwv_advisor0" type="radio" value="0" <?php checked('0', cwv_options::get('wp_cwv_advisor')); ?> />
                        <label for="wp_cwv_advisor0">no</label>
                        <input name="wp_cwv_advisor" id="wp_cwv_advisor1" type="radio" value="1" <?php checked('1', cwv_options::get('wp_cwv_advisor')); ?> />
                        <label for="wp_cwv_advisor1">yes</label>
                    </div>
                </td>
            </tr>
        </table> -->
    </div>

    <!-- <div class="g g11" data-depends="wp_cwv_advisor">
        <?php if (false ==  cwv_options::get('cwv_lcp_selector')) { ?>
            <div class="cwvcard warning mt tl pl">
                <h2><span>&#xbb;</span> Missing Critical configuration!</h2>
                <p>Identify the 'LCP' element. This is critical for any fast webpage. Navigate to the on 'Images' tab and update the 'LCP element' option.</p>
                <a href="https://dev.corewebvitals.io/wp-core-web-vitals/images#lcpel" target="_blank" class="button">Read the docs</a>
            </div>
        <?php } ?>


        <?php foreach (AdvisorDB::findTop() as $oAdvice) { ?>
            <div class="cwvcard warning mt pl advice ">
                <?php $aAdvise = json_decode($oAdvice->json, true); ?>
                <h2><span>&#xbb;</span> Preload this LCP image</h2>
                <div class="gridimg">
                    <div class="imgobjfit">
                        <img src="<?php echo $aAdvise['src']; ?>">
                    </div>
                    <div>
                        <p class="mp0">Slow LCP image found on: <?php echo $aAdvise['url']; ?> <br />
                            <b>How to fix?</b> Click on Images, add the image class to the images to preload. Use className <?php echo formatCssClass($aAdvise['class']); ?>
                            or from the parent class <?php echo formatCssClass($aAdvise['parentclass']); ?>
                        </p>
                    </div>
                </div>
            </div>

        <?php } ?>
    </div>


    <div class="cwvcard mt">
        <h2>Fix the Time To First Byte</h2>
        <p>
            You rTime to First Byte is a bit high (p75 = 911ms). Please enable Caching, Consider enbling more caching and check out these tips
        </p>
    </div> -->











    <h2 class="cwv-tab-heading"><svg class="icon">
            <use xlink:href="#icon-refresh"></use>
        </svg>Cache</h2>
    <p>* WP Core Web Vitals will clear it's cache automatically. On site-wide changes clear the cache manually.</p>
    <a id="clearhtmlcache" class="button button-primary" href="#">Clear HTML Cache</a>
    <a id="clearcriticalcache" class="button button-primary" href="#">Clear Critical CSS Cache</a>
</div>