<?php

namespace WPCWV;

if (!defined('ABSPATH')) {
    die('Let\'s not do this');
}


class cwv_critical_css
{
    public static function init()
    {
        add_action('cwv_generate_critical', 'WPCWV\cwv_critical_css::fn_cwv_generate_critical', 10, 0);
        add_action('wp_ajax_cwv_generate_critical', 'WPCWV\cwv_critical_css::fn_cwv_generate_critical', 10, 0);
        add_action('wp_ajax_delete_critical_css_rule', 'WPCWV\cwv_critical_css::delete_critical_css_rule');
        add_action('wp_ajax_wp_cwv_get_critical_css_rules', 'WPCWV\cwv_critical_css::wp_cwv_get_critical_css_rules');
    }



    /* fetch critical css for any page */
    public static function fn_cwv_generate_critical()
    {
        global $wpdb;

        $data = $wpdb->get_row('SELECT * FROM ' . $wpdb->prefix . 'cwv_criticalfiles WHERE status="open"');

        if (is_object($data)) {

            $http = wp_remote_get('http://critical2.corewebvitals.io/critical/critical.php?url=' . $data->url . '&version=' . WP_CWV_VERSION . '&key=' . WP_CWV_LICENCE_KEY, ['timeout' => 90]);
            $res = json_decode($http['body'], true);
            if ($res['css']) {

                // clear cache
                $files = glob(WP_CONTENT_DIR . '/cache/wp_cwv/html/ccss_*');
                foreach ($files as $file) {
                    if (is_file($file)) {
                        unlink($file);
                    }
                }

                // save critical css
                @mkdir(WP_CONTENT_DIR . '/cache/wp_cwv/critical/', 0777, true);
                file_put_contents(WP_CONTENT_DIR . '/cache/wp_cwv/critical/' . $data->hash . '.css', $res['css']);
            }

            /* should move this to DbQueries*/
            $table = $wpdb->prefix . 'cwv_criticalfiles';
            $tabledata = [
                'status' => 'done'
            ];

            $format = ['%s'];

            $where = [
                'id' => $data->id,
            ];

            $result2 = $wpdb->update($table, $tabledata, $where, $format, $format);



            // load next schedule
            if (!wp_next_scheduled('cwv_generate_critical')) {
                wp_schedule_single_event(time() + 10, 'cwv_generate_critical');
            }
        }
    }




    /* delete all critical css rules*/
    public static function delete_critical_css_rule()
    {
        CriticalRulesDB::delete($_POST['id']);
    }


    /* the critical rules are ajax loaded */
    public static function wp_cwv_get_critical_css_rules()
    {
        $oCriticalRules = CriticalRulesDB::findAll();

        echo '<table class="form-table">';
        foreach ($oCriticalRules as $oCriticalRule) {
            echo '<tr valign="top">';
            echo '<th scope="row">'.WP_CWV_SITE_URL.'</th>';
            echo '<td><input type="text" name="criticalcssrules['.$oCriticalRule->id.'" value="'.esc_attr($oCriticalRule->rule).'" /></td>';
            echo '<td><span class="deleterule button button-primary" data-id="'.$oCriticalRule->id.'">X</span></td>';
            echo '</tr>';
        }
        echo '<tr valign="top">';
        echo '<th scope="row">'.WP_CWV_SITE_URL.'</th>';
        echo '<td><input type="text" name="criticalcssrules[new]" value="" /></td>';
        echo '</tr>';
        echo '</table>';

        die();
    }




}
